indexing
	description: "[
					This is a prototype game called DRAGOONY.
					EiffelStudio 6.0 and the EiffelMedia library is required (1.0 - Blackbird).
				   	]"
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class

	DRAGOONY

inherit

	EM_APPLICATION

	EM_SHARED_THEME
		export {NONE} all end

	EM_AUDIO_CONSTANTS
		export {NONE} all end

	DR_CONSTANTS

create
	make


feature {NONE} -- Creation

	make is
			-- Create the main application.
		local
			keyboard: EM_KEYBOARD
		do

			set_application_id ("dragoony")
			set_window_width (DR_width)
			set_window_height (DR_height)
			set_screen_resolution (DR_resolution)
			set_opengl (false)

			video_subsystem.set_fullscreen (false)
			video_subsystem.set_hardware_surface (false)
			video_subsystem.set_software_surface (true)

			--video_subsystem.set_resizeable (true)

			video_subsystem.enable
			--audio_subsystem.enable
			--network_subsystem.enable
			--joystick_subsystem.enable

			initialize_screen

			-- check initialization
			if
				video_subsystem.is_enabled
				--audio_subsystem.is_enabled
				--network_subsystem.is_enabled
				--joystick_subsystem.is_enabled
			then
				-- set global options
				set_window_icon("./pics/dragoony_icon.png")
				set_window_title ("Dragoony")
				video_subsystem.show_cursor

				-- Open mixer with a frequency of 44.10 kHz
				--audio_subsystem.mixer.open (44100, Em_audio_format_s16sys, Em_stereo, Em_default_chunk_size)

				create keyboard.make_snapshot
				keyboard.enable_unicode_characters

				load_eclipse_theme

				-- set the first scene
				set_scene (create {START}.make)

				--play_music ("my_music.ogg")

				-- launch the scene
				launch

				-- disable subsystems
				video_subsystem.disable
				--audio_subsystem.disable
				--network_subsystem.disable
				--joystick_subsystem.disable
			else
				if not Video_subsystem.is_enabled then
					io.error.put_string ("Failed to initialise video subsystem.%N")
				end
				--if not Audio_subsystem.is_enabled then
				--	io.error.put_string ("Failed to initialise audio subsystem.%N")
				--end
				--if not Network_subsystem.is_enabled then
				--	io.error.put_string ("Failed to initialise network subsystem.%N")
				--end
				--if not Joystick_subsystem.is_enabled then
				--	io.error.put_string ("Failed to initialise joystick subsystem.%N")
				--end
			end
		end


end	-- class DRAGOONY
