indexing
	description: "Objects that represent the exit in the game levels."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	EXIT

inherit

 	DR_SPRITE_OBJECT
 	redefine
		--make_from_animation
		make_from_drawable
	end

create
	--make_from_animation
	make_from_drawable


feature {NONE} -- Creation

	make_from_drawable (a_drawable: EM_DRAWABLE; delay, an_x, a_y: INTEGER) is
			-- Create the EXIT object.
		do
			precursor (a_drawable, delay, an_x, a_y)
			set_do_loop (true)
			start
			set_arrived (false)
			image_offset_x := 0.0
			image_offset_y := 0.0
			-- Call create from EM_RECTANGLE_COLLIDABLE to ensure the logger gets created (EM_LOGGING class invariant).
			make_from_rectangle (bounding_box)
		end


feature -- Status setting

	set_arrived (b:BOOLEAN) is
			-- Set the arrived status.
		do
			arrived := b
		ensure
			arrived_set: arrived = b
		end


feature -- Status

	type_id: INTEGER is
			-- The id given to all instances of `current' generating class.
		do
			result := EXIT_ID
		end


feature -- Collision handling

	on_collide (other: DR_OBJECT; collision: EM_COLLISION [DR_OBJECT]; frame_delay: INTEGER) is
			-- `current' collided with `other'
		do
			if other.type_id = DRAGON_ID then
				set_arrived (true)
			end
		end


feature -- Implementation

	arrived: BOOLEAN
			-- Has the dragon arrived yet?


end -- class EXIT
