indexing
	description: "Objects that represent 1000 bonus points."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	POINT_BONUS

inherit
	BONUS
	redefine
		make_from_animation
	end

create
	make_from_animation


feature {NONE} -- Creation

	make_from_animation (an_animation: EM_ANIMATION; an_x, a_y: INTEGER) is
			-- Create the POINT_BONUS object.
		do
			PRECURSOR (an_animation, an_x, a_y)
			set_do_loop (true)
			start
			set_collected (false)
			image_offset_x := 0.0
			image_offset_y := 0.0
			-- Call create from EM_RECTANGLE_COLLIDABLE to ensure the logger gets created (EM_LOGGING class invariant).
			make_from_rectangle(bounding_box)
		end


feature -- Status

	type_id: INTEGER is
			-- The id given to all instances of `current' generating class.
		do
			result := POINT_BONUS_ID
		end

	bonus: INTEGER is
			-- the number of points
		do
			result := 1000
		end


feature -- Collision handling

	on_collide (other: DR_OBJECT; collision: EM_COLLISION [DR_OBJECT]; frame_delay: INTEGER) is
			-- `current' collided with `other'
		do
			if other.type_id = DRAGON_ID then
				set_collected (true)
			end
		end


end -- class POINT_BONUS
