indexing
	description: "Objects that represent fixed stones in the game."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	STONE_FIXED

inherit

	DR_SPRITE_OBJECT
	redefine
		--make_from_animation
		make_from_drawable
	end

create
	--make_from_animation
	make_from_drawable


feature {NONE} -- Creation

	make_from_drawable (a_drawable: EM_DRAWABLE; delay, an_x, a_y: INTEGER) is
			-- Create the STONE_FIXED object.
		do
			precursor(a_drawable, delay, an_x, a_y)
			set_do_loop (true)
			start
			image_offset_x := 0.0
			image_offset_y := 0.0
			-- Call create from EM_RECTANGLE_COLLIDABLE to ensure the logger gets created (EM_LOGGING class invariant).
			make_from_rectangle (bounding_box)
		end


feature -- Status

	type_id: INTEGER is
			-- The id given to all instances of `current' generating class.
		do
			result := STONE_FIXED_ID;
		end


feature -- Collision handling

	on_collide (other: DR_OBJECT; collision: EM_COLLISION [DR_OBJECT]; frame_delay: INTEGER) is
			-- `current' collided with `other'
		do
			-- Do nothing, these collisions are handled by the objects bumping into the stone.
		end


end -- class STONEFIX
