indexing
	description: "This is the second level of Dragoony."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	ZLEVEL02

inherit
	ZLEVEL

create
	make_level


feature {NONE} -- Creation

	make_level is
			-- Create the level.
		do
			make_scene
			-- from EM_SCENE, must be called
		end


feature -- Commands

	create_floor: EM_BITMAP is
			-- Simply choose the picture used for the floor in this level.
		do
			bitmap_factory.create_bitmap_from_image ("./pics/floor2.jpg")
			result := bitmap_factory.last_bitmap
		end


	create_dragon is
			-- Create the dragon and position it in the level.
		local
			anim: EM_ANIMATION
		do
			create anim.make_from_file ("./pics/dragon.anim")
			create dragon.make_from_animation (anim, 100, 350)
		end


	create_interior_walls is
			-- Create some walls in the level.
		local
			image: EM_BITMAP
			sbv: STONE_BORDER_VERTICAL

		do
			create walls_interior.make
			bitmap_factory.create_bitmap_from_image ("./pics/stonefix.gif")
			image := bitmap_factory.last_bitmap
			image.set_transparent_color (0, 0, 0)


			create sbv.make (image, 4)
			sbv.set_x_y (200, 85)
			sbv.move_by (200, 85)
			walls_interior.put_last (sbv)

			create sbv.make (image, 2)
			sbv.set_x_y (200, 85+5*image.height)
			sbv.move_by (200, 85+5*image.height)
			walls_interior.put_last (sbv)

			create sbv.make (image, 2)
			sbv.set_x_y (400, 85)
			sbv.move_by (400, 85)
			walls_interior.put_last (sbv)

			create sbv.make (image, 4)
			sbv.set_x_y (400, 85+3*image.height)
			sbv.move_by (400, 85+3*image.height)
			walls_interior.put_last (sbv)

			create sbv.make (image, 4)
			sbv.set_x_y (600, 85)
			sbv.move_by (600, 85)
			walls_interior.put_last (sbv)

			create sbv.make (image, 2)
			sbv.set_x_y (600, 85+5*image.height)
			sbv.move_by (600, 85+5*image.height)
			walls_interior.put_last (sbv)

		end


	create_moving_stones is
			-- Create some moving stones.
		do

		end


	create_bonus is
			-- Create some point bonuses.
		local
			anim: EM_ANIMATION
			pb: POINT_BONUS
		do
			create bonus.make
			create anim.make_from_file ("./pics/bonus1000.anim")

			create pb.make_from_animation (anim, 300, 200)
			bonus.put_last (pb)

			create pb.make_from_animation (anim, 800, 100)
			bonus.put_last (pb)

		end


	create_aliens is
			-- Create some aliens which populate the level.
		local
			anim: EM_ANIMATION
			alien: ALIEN
			dir: EM_VECTOR_2D
		do
			create aliens.make
			create anim.make_from_file ("./pics/alien.anim")

			create alien.make_from_animation (anim, 300, 300)
			create dir.make (0.0, -1.0)
			alien.set_direction (dir)
			alien.set_state (UP)
			aliens.put_last (alien)

			create alien.make_from_animation (anim, 500, 500)
			create dir.make (0.0, 1.0)
			alien.set_direction (dir)
			alien.set_state (DOWN)
			aliens.put_last (alien)

		end


	create_exit is
			-- Set the position for the exit in this level.
		local
			img: EM_BITMAP
		do
			bitmap_factory.create_bitmap_from_image ("./pics/door.gif")
			img := bitmap_factory.last_bitmap
			img.set_transparent_color (255, 255, 255)
			create exit.make_from_drawable (img, 10000, 875, 375)
		end


feature {NONE} -- Miscellaneous

	move_aliens is
		local
			alien: ALIEN
			dir: EM_VECTOR_2D
			state: INTEGER
			cursor: DS_LINKED_LIST_CURSOR [ALIEN]
		do
			if aliens /= void then

				create dir.make (0.0, 0.0)

				create cursor.make (aliens)
				from
					cursor.start
				until
					cursor.after
				loop
					alien := cursor.item
					state := alien.state
					dir.set_x (0.0)
					dir.set_y (0.0)


					if state = UP then -- moving up
						if alien.border_top >= 0 then
							dir.set_y (-1.0)
							alien.set_direction (dir)
							alien.step_by (frame_delay)

						else
							dir.set_y (1.0)
							alien.set_direction (dir)
							alien.step_by (frame_delay)
							alien.set_state (DOWN)
						end

					elseif state = DOWN  then -- moving down
						if alien.border_bottom <= screen.height then
							dir.set_y (1.0)
							alien.set_direction (dir)
							alien.step_by (frame_delay)
						else
							dir.set_y (-1.0)
							alien.set_direction (dir)
							alien.step_by (frame_delay)
							alien.set_state(UP)
						end

					elseif state = DEAD then -- The alien is dead, do not do anything.

					elseif state = NONE then -- The alien is stadning still.

					end

					cursor.forth
				end

			end
		end


	on_win is
			-- Called if the dragon reaches the exit, set next scene here.
		local
			level: ZLEVEL03
		do
			score:= score + 10000
			create level.make_level
			level.set_score (score)
			level.set_lives (lives)
			set_next_scene (level)
			start_next_scene
		end


end -- class ZLEVEL02
