indexing
	description: "This is the sixth level of Dragoony."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	ZLEVEL06

inherit
	ZLEVEL

create
	make_level


feature {NONE} -- Creation

	make_level is
			-- Create the level.
		do
			make_scene
			-- from EM_SCENE, must be called
		end


feature -- Commands

	create_floor: EM_BITMAP is
			-- Choose the picture used for the floor in this level.
		do
			bitmap_factory.create_bitmap_from_image ("./pics/floor1.jpg")
			result := bitmap_factory.last_bitmap
		end


	create_dragon is
			-- Create the dragon and position it in the level.
		local
			anim: EM_ANIMATION
		do
			create anim.make_from_file ("./pics/dragon.anim")
			create dragon.make_from_animation (anim, 100, 350)
		end


	create_interior_walls is
			-- Create some interior walls in the level.
		local
			image: EM_BITMAP
			sbh: STONE_BORDER_HORIZONTAL
			sbv: STONE_BORDER_VERTICAL
		do
			create walls_interior.make

			bitmap_factory.create_bitmap_from_image ("./pics/stonefix.gif")
			image := bitmap_factory.last_bitmap
			image.set_transparent_color (0,0,0)

			create sbv.make (image, 2)
			sbv.set_x_y (250, 85)
			sbv.move_by (250, 85)
			walls_interior.put_last (sbv)

			create sbh.make (image, 2)
			sbh.set_x_y (250, 85+2*image.height)
			sbh.move_by (250, 85+2*image.height)
			walls_interior.put_last (sbh)

		end


	create_moving_stones  is
			-- Create some moving stones.
		do

		end


	create_bonus is
			-- Create some point bonuses.
		do

		end


	create_aliens is
			-- Create the one and only alien for this level.
		do
			create aliens.make
			create alien.make_from_animation (create {EM_ANIMATION}.make_from_file ("./pics/alien.anim"), 800, 300)
			alien.set_direction ( create {EM_VECTOR_2D}.make (0.0, 0.0) )
			alien.set_state (NONE)
			aliens.put_last (alien)
		end


	create_exit is
			-- Set the position for the exit in this level.
		local
			img: EM_BITMAP
		do
			bitmap_factory.create_bitmap_from_image ("./pics/door.gif")
			img := bitmap_factory.last_bitmap
			img.set_transparent_color (255, 255, 255)
			create exit.make_from_drawable (img, 10000, 875, 375)
		end


feature {NONE} -- Miscellaneous

	move_aliens is
		local
			dir: EM_VECTOR_2D
				--the alien's moving direction
		do
			create dir.make (0.0, 0.0)

			if pressed_keys.item (UP) then
				dir.add ( create {EM_VECTOR_2D}.make (0.0, -1.0) )
			end

			if pressed_keys.item (LEFT) then
				dir.add ( create {EM_VECTOR_2D}.make (-1.0, 0.0) )
			end

			if pressed_keys.item (RIGHT) then
				dir.add ( create {EM_VECTOR_2D}.make (-1.0, 0.0) )
			end

			if pressed_keys.item (DOWN) then
				dir.add ( create {EM_VECTOR_2D}.make (0.0, 1.0) )
			end

			alien.set_direction (dir)
			if dir.length > 0.0 then
				-- Only move the alien if there is user input {UP, DOWN, LEFT, RIGHT}.
				alien.step_by (frame_delay)
				alien.set_x_y ( (alien.corner_top_left.x - alien.image_offset_x).floor, (alien.corner_top_left.y - alien.image_offset_y).floor )
			end

		end


	on_win is
			-- Called if the dragon reaches the exit, set next scene here.
		--local
		--	level: ZLEVEL07
		do
			--score := score + 10000	
			--create level.make_level
			--level.set_score (score)
			--level.set_lives (lives)
			set_next_scene (create {START}.make)
			start_next_scene
		end


	alien: ALIEN
		-- Only one alien in this level, do not use the aliens DS_LINKED_LIST inherited from ZLEVEL.


end -- class ZLEVEL06
