indexing
	description: "INSTRUCTIONS represents the instructions menu."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	INSTRUCTIONS

inherit

	MENU

	EM_SHARED_SUBSYSTEMS
	export
		{NONE} all
	end

create
	make


feature {NONE} -- Creation

	make is
			-- Create the INSTRUCTION menu.
		local
			a_button: MENU_BUTTON
			a_font: EM_BMP_FONT
			a_label: EM_LABEL
		do
			initialize_menu

			-- create menu buttons
			create a_button.make ("Back")
			a_button.set_position (width // 2 - a_button.width // 2, 750 + 0 * 50)
			a_button.pressed_event.subscribe (agent back_button_pressed)
			add_button (a_button)

			set_selected_menu_item(1)

			-- compose instructions listing
			bitmap_factory.create_bitmap_from_image("./pics/arial256.gif")
			create a_font.make(bitmap_factory.last_bitmap)

			create a_label.make_from_text ("LEFT: Move left")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540)
			add_widget(a_label)

			create a_label.make_from_text ("RIGHT: Move right")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540 + 32)
			add_widget(a_label)

			create a_label.make_from_text ("UP: Move up")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540 + 2*32)
			add_widget(a_label)

			create a_label.make_from_text ("DOWN: Move down")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540 + 3*32)
			add_widget(a_label)

			create a_label.make_from_text ("ESC: Return to the Start menu")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540 + 4*32)
			add_widget(a_label)

			create a_label.make_from_text ("f or F: Toggle framecounter")
			a_label.set_font(a_font)
			a_label.resize_to_optimal_dimension
			a_label.set_position (200, 540 + 5*32)
			add_widget(a_label)

			video_subsystem.show_cursor

		end


feature {NONE} -- Event handler

	back_button_pressed is
			-- back button pressed
		do
			set_next_scene (create {START}.make)
			start_next_scene
		end


end -- class INSTRUCTIONS
