indexing
	description: "Objects that represent a menu button."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2012-01-15 $"
	revision: "$Revision: 0.8$"

class
	MENU_BUTTON

inherit
	EM_LABEL

	EM_SHARED_STANDARD_FONTS
	export
		{NONE} all
	end

create
	make


feature {NONE} -- Creation

	make (a_text: STRING) is
			-- Create the MENU_BUTTON object.
		require
			text_not_void: a_text /= Void
		do
			create pressed_event
			make_from_text (a_text)
			set_font (Standard_ttf_fonts.bitstream_vera_sans_bold (28))
			set_foreground_color (create {EM_COLOR}.make_white)
			resize_to_optimal_dimension
			mouse_clicked_event.subscribe (agent handle_mouse_clicked)
		end


feature -- Events

	pressed_event: EM_EVENT_CHANNEL[TUPLE[]]

	handle_mouse_clicked (an_event: EM_MOUSEBUTTON_EVENT) is
			-- handle mouse click
		do
			pressed_event.publish ([])
		end


end -- class MENU_BUTTON
