indexing
	description: "START describes the start menu."
	author: "Lukas Novosad - novosprotos@eblcom.ch"
	date: "$Date: 2005-06-15 11:55:15 +0200 (Mi, 15 Jun 2005) $"
	revision: "$Revision: 0.8 $"

class
	START

inherit

	MENU

	EM_SHARED_SUBSYSTEMS
		export
			{NONE} all
		end

create
	make


feature {NONE}  -- Initialization

	make is
		-- Creates the START menu object.
		local
			button: MENU_BUTTON
			a_label: EM_LABEL
		do
			initialize_menu

			-- create menu items
			create button.make ("Start")
			button.set_position (width // 2 - button.width // 2, 540 + 0 * 50)
			button.pressed_event.subscribe (agent singleplayer_button_pressed)
			add_button (button)

			create button.make ("Instructions")
			button.set_position (width // 2 - button.width // 2, 540 + 1 * 50)
			button.pressed_event.subscribe (agent instructions_button_pressed)
			add_button (button)

--			create button.make ("Options")
--			button.set_position (width // 2 - button.width // 2, 540 + 2 * 50)
--			button.pressed_event.subscribe (agent options_button_pressed)
--			add_button (button)

			create button.make ("Quit")
			button.set_position (width // 2 - button.width // 2, 540 + 2 * 50)
			button.pressed_event.subscribe (agent back_button_pressed)
			add_button (button)

			set_selected_menu_item(1)

			video_subsystem.show_cursor
		end


feature {NONE} -- Event handler

	singleplayer_button_pressed is
			-- singleplayer button pressed
		--local
		--	level: ZLEVEL01
		do
		--	create level.make_level
		--	level.set_lives(4)
		--	set_next_scene (level)
			set_next_scene (create {ZLEVEL01}.make_level)
			start_next_scene
		end


	instructions_button_pressed is
			-- instructions button pressed
		do
			set_next_scene (create {INSTRUCTIONS}.make)
			start_next_scene
		end


	back_button_pressed is
			-- exit button pressed
		do
			quit
		end

end -- class START
